various fixes
[automated-distro-installer] / wrt-setup-local
index 92056976da74d45033accbb7518a8db13b2545c8..d5910c0d84c2a40b3cbd6572217c6e4089752923 100755 (executable)
@@ -16,8 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 
 
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+f=/usr/local/lib/err;test -r $f || { echo "error: $0 no $f" >&2;exit 1;}; . $f
 
 
 usage() {
@@ -94,12 +93,14 @@ shift "$((OPTIND-1))"   # Discard the options and sentinel --
 
 if [[ $1 ]]; then
   h=$1
-  hostname=$h
 else
   h=cmc
+fi
+if [[ ! $hostname ]]; then
   hostname=$h
 fi
 
+
 secrets=false
 if [[ -e /root/router-secrets ]]; then
   secrets=true
@@ -235,7 +236,8 @@ mask=255.255.0.0
 cidr=16
 l=${lan%.0}
 
-passwd -l root ||: #already locked fails
+# why did we lock this? i don't know
+#passwd -l root ||: #already locked fails
 
 sed -ibak '/^root:/d' /etc/shadow
 # /root/router created by manually running passwd then copying the resulting
@@ -379,8 +381,13 @@ esac
 #
 # relay package temporarily disabled
 # /root/relay_1.0-1_mips_24kc.ipk
+#
+# note: prometheus-node-exporter-lua-openwrt seems to be a dependency of
+# prometheus-node-exporter-lua in practice.
 v pi tcpdump screen rsync unbound-daemon unbound-checkconf \
-  kmod-usb-storage block-mount kmod-fs-ext4
+  kmod-usb-storage block-mount kmod-fs-ext4 \
+  prometheus-node-exporter-lua-openwrt \
+  prometheus-node-exporter-lua
 # nfs-kernel-server \
   #   openvpn-openssl adblock libusb-compat \
   #   kmod-usb-serial-cp210x kmod-usb-serial-ftdi \
@@ -458,7 +465,17 @@ EOF
 # v /etc/init.d/nfsd enable
 
 
+cedit /etc/config/prometheus-node-exporter-lua <<'EOF' || /etc/init.d/prometheus-node-exporter-lua restart
+config prometheus-node-exporter-lua 'main'
+        option listen_ipv6 '0'
+        option listen_interface 'lan'
+        option listen_port '9100
+EOF
 
+# default, as of this writing is:
+# config prometheus-node-exporter-lua 'main'
+#      option listen_interface 'loopback'
+#      option listen_port '9100'
 
 
 
@@ -565,6 +582,7 @@ EOF
       ;;
   esac
 
+
   cedit /etc/config/firewall <<EOF
 ## begin no external dns for ziva
 config rule
@@ -621,6 +639,32 @@ config rule
  option target           ACCEPT
  option dest_port        22
 
+config redirect
+ option name promkd
+ option src              wan
+ option src_dport        9091
+ option dest_port        9091
+ option dest_ip          $l.2
+ option dest             lan
+config rule
+ option src              wan
+ option target           ACCEPT
+ option dest_port        9091
+
+
+config redirect
+ option name nagioskd
+ option src              wan
+ option src_dport        3005
+ option dest_port        3005
+ option dest_ip          $l.2
+ option dest             lan
+config rule
+ option src              wan
+ option target           ACCEPT
+ option dest_port        3005
+
+
 config redirect
  option name sshkd
  option src              wan
@@ -722,7 +766,7 @@ config rule
 
 
 config redirect
- option name httpkd
+ option name http
  option src              wan
  option src_dport        80
  option dest             lan
@@ -735,7 +779,7 @@ config rule
  option proto            tcp
 
 config redirect
- option name httpskd
+ option name https
  option src              wan
  option src_dport        443
  option dest             lan
@@ -826,17 +870,39 @@ config rule
  option target ACCEPT
  option family ipv6
 
-# include a file with users custom iptables rules
-config include
-       option path /etc/firewall.user
-       option type 'restore'
-       option family 'ipv4'
+# not using and in newer wrt, fails, probably due to nonexistent file, error output
+# on
+
+# Reference error: left-hand side expression is not an array or object
+# In [anonymous function](), file /usr/share/ucode/fw4.uc, line 3137, byte 12:
+#   called from function [arrow function] (/usr/share/ucode/fw4.uc:733:71)
+#   called from function foreach ([C])
+#   called from function [anonymous function] (/usr/share/ucode/fw4.uc:733:72)
+#   called from function render_ruleset (/usr/share/firewall4/main.uc:56:24)
+#   called from anonymous function (/usr/share/firewall4/main.uc:143:29)
+
+#  `        if (!inc.enabled) {`
+#   Near here -------^
+#
+#
+# The rendered ruleset contains errors, not doing firewall restart.
+# /usr/bin/wrt-setup-local:160:error: ""$@"" returned 1
 
 
+## include a file with users custom iptables rules
+#config include
+#      option path /etc/firewall.user
+#      option type 'restore'
+#      option family 'ipv4'
+
 EOF
 }
 firewall-cedit || firewall_restart=true
 
+
+
+
+
 # not using wireguard for now
 # if ! uci get firewall.@zone[1].network | grep wg0 &>/dev/null; then
 #   # cant mix cedit plus uci
@@ -880,7 +946,7 @@ uset dhcp.@dnsmasq[0].local
 # note: tried this, it didn't do anything:
 # uset dhcp.@odhcpd[0].dns 10.2.0.1
 
-# iank, disabled while debugging.
+# iank, disablde while debugging.
 #/etc/init.d/odhcpd stop
 #/etc/init.d/odhcpd disable
 
@@ -922,9 +988,13 @@ EOF
 
   if $zblock; then
     cat <<'EOF'
-# syw, samsungtab
 # no sy until that dongle is used by ziva
-access-control-view: 10.2.0.7/32 "youtube"
+
+# syw
+#access-control-view: 10.2.0.7/32 "youtube"
+# bow
+access-control-view: 10.2.0.29/32 "youtube"
+# samsungtab
 access-control-view: 10.2.0.32/32 "youtube"
 EOF
   fi
@@ -960,6 +1030,8 @@ local-data-ptr: "10.173.8.2 nn.b8.nz"
 
 forward-zone:
   name: "."
+#  forward-addr: 8.8.8.8
+#  forward-addr: 8.8.8.8
 # https://developers.cloudflare.com/1.1.1.1/1.1.1.1-for-families/setup-instructions/dns-over-https
   forward-addr: 1.1.1.3@853#family.cloudflare-dns.com
   forward-addr: 1.0.0.3@853#family.cloudflare-dns.com
@@ -1026,8 +1098,13 @@ rebind-domain-ok=b8.nz
 # It is default if dnsmasq is doing dns, otherwise, we have to specify it.
 # To see it in action, I ran this from a client machine:
 # sudo dhcpcd -o domain_name_servers -T
-dhcp-option=6,$l.1
+dhcp-option=option:dns-server,$l.1
 
+# use this when doing fai to get the right timezone, its nfsroot is
+# setup to use this dhcp option only and call ntpdate.
+# generate ips with:
+# for h in 0.ubuntu.pool.ntp.org 1.ubuntu.pool.ntp.org ntp.ubuntu.com; do host -t a $h | awk '{print $NF}'; done | while read -r l; do printf ,$l; done
+dhcp-option=option:ntp-server,188.165.3.28,202.12.97.45,91.236.251.13,50.205.244.23,78.30.254.80,31.131.0.123,202.65.114.202,94.228.220.14,185.125.190.57,185.125.190.58,91.189.91.157,185.125.190.56,91.189.94.4
 
 
 # results from googling around dnsmasq optimizations
@@ -1075,19 +1152,20 @@ dhcp-host=94:05:bb:1e:2c:2e,set:sy,$l.3,sy
 # top port, iPXE (PCI 04:00.0) in seabios boot menu
 #dhcp-host=c8:60:00:2b:15:07,set:kd,$l.2,kd
 # 4 is reserved for a staticly configured host wrt2
-# old x2 with bad fan
-#dhcp-host=00:1f:16:16:39:24,set:x2,$l.5,x2
 dhcp-host=f0:de:f1:81:ec:88,set:x2,$l.5,x2
 dhcp-host=c4:8e:8f:44:f5:63,set:x2w,$l.6,x2w
-dhcp-host=34:7d:f6:ed:ec:07,set:syw,$l.7,syw
+dhcp-host=10:51:07:f5:f1:b8,set:syw,$l.7,syw
 dhcp-host=80:fa:5b:1c:6e:cf,set:amy,$l.8,amy
 # This is so fai can have an explicit name to use for testing,
 # or else any random machine which did a pxe boot would get
 # reformatted. The mac is from doing a virt-install, cancelling it,
 # and copying the generated mac, so it should be randomish.
 dhcp-host=52:54:00:9c:ef:ad,set:demohost,$l.12,demohost
+## for using different dhcp server
+#dhcp-host=52:54:00:9c:ef:ad,ignore
 dhcp-host=62:03:cb:a8:3e:a3,set:trp,$1.13,trp
 # 14 = wrt3
+dhcp-host=ac:d1:b8:5c:eb:d7,set:x3w,$l.17,x3w
 dhcp-host=00:1f:16:14:01:d8,set:x3,$l.18,x3
 # BRN001BA98CA823 in dhcp logs
 dhcp-host=00:1b:a9:8c:a8:23,set:brother,$l.19,brother
@@ -1099,11 +1177,17 @@ dhcp-host=00:26:b6:f6:0f:e9,set:frodow,$l.28,frodow
 dhcp-host=70:a6:cc:3a:bb:b4,set:bow,$l.29,bow
 dhcp-host=6c:56:97:88:7b:74,set:amazontab,$l.31,amazontab
 dhcp-host=0a:8a:9b:cf:b5:ec,set:samsungtab,$l.32,samsungtab
-
+dhcp-host=b8:27:eb:78:21:1d,set:pi3b,$l.33,pi3b
+# old x2 with bad fan
+dhcp-host=00:1f:16:16:39:24,set:x8,$l.38,x8
+# server d16:
+dhcp-host=38:2c:4a:c9:33:13,set:bigs,$l.48,bigs
+dhcp-host=e4:5f:01:07:50:40,set:pi4w,$l.49,pi4
+dhcp-host=e4:5f:01:07:50:3f,set:pi4,$l.50,pi4w
 
 
 # faiserver vm
-dhcp-host=52:54:00:56:09:f9,set:faiserver,$l.15,faiserver
+#dhcp-host=52:54:00:56:09:f9,set:faiserver,$l.15,faiserver
 
 # This is the ip it picks by default if dhcp fails,
 # so might as well use it.
@@ -1113,12 +1197,16 @@ dhcp-host=b4:75:0e:94:29:ca,set:switch9429ca,$l.251,switch9429ca
 # template
 # dhcp-host=,$l.,
 
-# uncomment to do tftpboot. openwrt snapshot from 2022-01, seems like it cant
-# access /mnt/usb/tftpboot due to some jail or sandbox thing
+# pxe tftpboot for arch-like. todo: openwrt snapshot from 2022-01, it cant
+# access /mnt/usb/tftpboot due to ujail sandbox
 #enable-tftp=br-lan
 #tftp-root=/mnt/usb/tftpboot
-#dhcp-optsfile=/etc/dnsmasq-dhcpopts.conf
+#tftp-root=/var/run/dnsmasq/tftpboot
+
 
+dhcp-optsfile=/var/run/dnsmasq/dhcpopts.conf
+
+# for debugging dhcp
 #log-queries=extra
 EOF
 
@@ -1144,6 +1232,10 @@ if $firewall_restart; then
   v /etc/init.d/firewall restart
 fi
 
+# turn off luci
+/etc/init.d/uhttpd stop
+/etc/init.d/uhttpd disable
+
 # this may just restart the network and take care of the network_restart below.
 if $wireless_restart; then
   v wifi